#include "application.h"
#include <QStringList>
#include <apt-pkg/debversion.h>
#include <QDebug>

Application::Application(QQuickItem *parent) :
    QQuickItem(parent)
{
    this->m_packagename = "";
    this->m_title = "";
    this->m_local_version = "";
    this->m_remote_version = "";
    this->m_dbuspath = "";
    this->m_update = false;
    this->m_update_state = false;
    this->m_selected = false;
}

void Application::initializeApplication(QString packagename, QString title, QString version)
{
    this->m_packagename = packagename;
    this->m_title = title;
    this->m_local_version = version;
}

void Application::setRemoteVersion(QString& version)
{
    this->m_remote_version = version;

    debVersioningSystem debVersion;

    int result = debVersion.CmpVersion(this->m_local_version.toUtf8().data(),
                                       this->m_remote_version.toUtf8().data());
    if(result == -1) {
        this->m_update = true;
    }else{
        this->m_update = false;
    }
}
