#include "downloader.h"
#include <QVariantMap>
#include "metatypes.h"

Downloader::Downloader(QObject *parent) :
    QObject(parent)
{
    qDBusRegisterMetaType<StringMap>();
    this->manager = new DownloadManager("com.canonical.applications.Downloader", "/", QDBusConnection::sessionBus(), 0);
}

void Downloader::startDownload(QString& packagename, QString& url)
{
    QVariantMap vmap;
    StringMap map;
    QDBusPendingReply<QDBusObjectPath> reply = this->manager->createDownload(url, vmap, map);
    reply.waitForFinished();
    if (reply.isError()) {
        emit this->downloadNotCreated(packagename);
    }else{
        QDBusObjectPath path = reply.value();
        emit this->downloadCreated(packagename, path.path());
    }
}

