#ifndef NETWORK_H
#define NETWORK_H

#include <QObject>
#include <QtNetwork/QNetworkAccessManager>
#include <QtNetwork/QNetworkReply>
#include <QHash>
#include "application.h"

class Network : public QObject
{
    Q_OBJECT
public:
    explicit Network(QObject *parent = 0);

    void checkForNewVersions(QHash<QString, Application*> &apps);
    void getResourceUrl(QString packagename);

signals:
    void updatesFound();
    void updatesNotFound();
    void errorOccurred();
    void downloadUrlFound(QString packagename, QString url);

private slots:
    void onReply(QNetworkReply*);

private:
    QNetworkAccessManager* _nam;
    QNetworkRequest* _request;
    QHash<QString, Application*> _apps;
    QString m_temp_packagename;
};

#endif // NETWORK_H
